#!/bin/sh
# This script sets up the VDrift development environment for MSYS.

# The file name of the bash profile
mkdir -p /etc/profile.d
P="/etc/profile.d/vdrift.sh"

# Create bash profile for VDrift compilation in MSYS
echo "Setting up $P..."
echo "# This profile was created to set up MSYS VDrift development environment." > $P

# where VDrift is located - present working directory assumed
echo "export VDRIFT_DIR=\"$PWD\"" >> $P

# modify PATH to find Python
echo "export PATH=\$PATH:/c/Python25/:/c/Python25/Scripts" >> $P

# Bullet/Jam stuff
echo "export JAM_TOOLSET=MINGW" >> $P
echo "export BULLET_DIR=\"\$VDRIFT_DIR/bullet-2.66\"" >> $P

# source the new  profile
. $P

# copy jam.exe into MSYS bin directory, copy build scripts into bin dir, make them executable
echo "Installing jam.exe..."
cp "$PWD/tools/win/bin/jam.exe" /bin
echo "Installing build_vdrift.sh..."
cp "$PWD/tools/win/bin/build_vdrift.sh" /bin
echo "Installing build_bullet.sh..."
cp "$PWD/tools/win/bin/build_bullet.sh" /bin
chmod u+x /bin/build_*.sh
